<?php

namespace Lc\ShopBundle\Form\Backend\Filters;

use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\EntityRepository;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateTimeType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\FormType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;


class ListFilterType extends AbstractType
{
        protected $em;

        public function __construct(EntityManagerInterface $entityManager)
        {
                $this->em = $entityManager;
        }

        public function buildForm(FormBuilderInterface $builder, array $options)
        {

                foreach ($options['fields'] as $field) {

                        switch ($field['dataType']) {
                                case 'integer':
                                        $builder->add($field['property'], TextType::class, array(
                                                'required' => false,
                                                'attr'=>array(
                                                        'class'=> ' input-sm',
                                                        'form'=> 'filters-form'
                                                )
                                        ));
                                        break;
                                case 'string':
                                        $builder->add($field['property'], TextType::class, array(
                                                'required' => false,
                                                'attr'=>array(
                                                        'class'=> ' input-sm',
                                                        'form'=> 'filters-form'
                                                )
                                        ));
                                        break;
                                case 'toggle':
                                        $builder->add($field['property'], ChoiceType::class, array(
                                                'choices'=> array(
                                                        'Oui' => 1,
                                                        'Non' => 0,
                                                ),
                                                'placeholder'=> '--',
                                                'required'=>false,
                                                'attr'=>array(
                                                        'class'=> 'select2 input-sm',
                                                        'form'=> 'filters-form'
                                                )
                                        ));
                                        break;
                                case 'datetime':
                                case 'date':
                                        $builder->add(
                                                $builder->create($field['property'], FormType::class, array('inherit_data' => true))
                                                ->add('dateStart', DateType::class, array(
                                                        'widget' => 'single_text',
                                                        'required' => false,
                                                ))
                                                ->add('dateEnd', DateType::class, array(
                                                        'widget' => 'single_text',
                                                        'required' => false,

                                                ))
                                        );
                                        break;
                                case 'association':
                                        $classImplements = class_implements($field['targetEntity']);
                                        $builder->add($field['property'], EntityType::class, array(
                                                'class' => $field['targetEntity'],
                                                'placeholder'=> '--',
                                                'query_builder' => function (EntityRepository $repo) use ($classImplements) {
                                                        if (in_array('Lc\ShopBundle\Context\FilterMerchantInterface', $classImplements)) {
                                                                return $repo->findByMerchantQuery();
                                                        }else{
                                                                return $repo->createQueryBuilder('entity');
                                                        }

                                                },
                                                'required' => false,
                                                'attr'=>array(
                                                        'class'=> 'select2 input-sm',
                                                        'form'=> 'filters-form'
                                                )


                                        ));
                                        break;
                                case 'dateinterval':

                                        break;
                                case 'float':

                                        break;
                        }


                }
                /*                $builder
                                        ->add('title', TextType::class, [
                                                'label' => 'Titre',
                                                'required' => false,
                                        ])
                                        ->add('behaviorTaxRate', BehaviorTaxRateType::class)
                                        ->add('unit', UnitType::class)
                                        ->add('value', ValueType::class)
                                        ->add('permanent', PermanentType::class)
                                        ->add('dateStart', DateStartType::class)
                                        ->add('dateEnd', DateEndType::class)
                                        ->add('users', UsersFilterType::class)
                                        ->add('groupUsers', GroupUsersFilterType::class);*/
        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'label' => false,
                        'csrf_protection'=> false,
                        'translation_domain' => 'lcshop',
                        'fields' => false
                ]);
        }
}
